//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiUtilisateur {

    /** Permet de supprimer un utilisateur au sein d'un foyer */
    public enum PostApiUtilisateurSupprimer {

        public static let service = APIService<Response>(id: "postApiUtilisateurSupprimer", tag: "Api Utilisateur", method: "POST", path: "/apiUtilisateur/supprimer", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var identifiantUtilisateur: String

                public init(identifiantUtilisateur: String) {
                    self.identifiantUtilisateur = identifiantUtilisateur
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: PostApiUtilisateurSupprimer.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(identifiantUtilisateur: String) {
                let options = Options(identifiantUtilisateur: identifiantUtilisateur)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["identifiantUtilisateur"] = options.identifiantUtilisateur
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = Void

            /** Succes */
            case status200

            /** Erreur */
            case status400

            /** Erreur */
            case status500

            public var success: Void? {
                switch self {
                case .status200: return ()
                default: return nil
                }
            }

            public var response: Any {
                switch self {
                default: return ()
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                case .status400: return 400
                case .status500: return 500
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                case .status400: return false
                case .status500: return false
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = .status200
                case 400: self = .status400
                case 500: self = .status500
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
